﻿using System;

namespace PivotGrouping
{
    public struct Money
    {
        public Money(decimal value, Currency currency)
        {
            this.Value = value;
            this.Currency = currency;
        }

        public decimal Value;
        public Currency Currency;

        public static Money operator +(Money a, Money b)
        {
            if (a.Currency != b.Currency)
            {
                throw new Exception("Can not sum money from different currencies!");
            }

            return new Money(a.Value + b.Value, a.Currency);
        }

        public override string ToString()
        {
            switch (this.Currency)
            {
                case Currency.Euro:
                    return string.Format("€ {0}", this.Value);
                case Currency.Pound:
                    return string.Format("£ {0}", this.Value);
                default:
                    throw new Exception("Unsupported currency!");
            }
        }
    }
}
