﻿using Telerik.Pivot.Core.Aggregates;

namespace PivotGrouping
{
    public class MoneySumAggregate : AggregateValue
    {
        private Money? Amount;
        protected override void AccumulateOverride(object value)
        {
            if (this.Amount == null)
            {
                this.Amount = (Money)value;
            }
            else
            {
                this.Amount += (Money)value;
            }
        }

        protected override object GetValueOverride()
        {
            return this.Amount;
        }

        protected override void MergeOverride(AggregateValue childAggregate)
        {
            Money? other = ((MoneySumAggregate)childAggregate).Amount;
            if (this.Amount == null)
            {
                this.Amount = other;
            }
            else if (other != null)
            {
                this.Amount += other;
            }
        }
    }
}
